var serverurl = "http://ceshi.kuaijilm.com/api/";

$(function() {

    //返回顶部
    $(".back_top").click(function(e) {
        $('body,html').animate({
            scrollTop: 0
        }, 500);
    });

});

//放回顶部
function scroll_top(){
  $('body,html').animate({
      scrollTop: 0
  }, 500);
}

// 截取字符串
function ellipsis(str, length = 15) {
    if (str.length > length) {
        str = str.substring(0, length) + '...';
    }
    return str;
}

/**
 * 手机号私密处理
 */
function private_phone(phone){

    return phone.substring(0, 3) + "****" + phone.substring(7, 11);
}

//去除数据空数据
function trim_array(arr){
    var data = [];
    if (arr.length > 0) {
      for (var i = 0; i < arr.length; i++) {
        if (!isEmpty(arr[i])) {
          data.push(arr[i])
        }
      }
    }
    return data;
}

//判断用户登录是否有效，是否购买课程
function is_login_open(sid, callback, is_exp){

    is_exp = is_exp || 0;

    var uid = $api.getStorage('uid'),
        device = api.deviceId;
    api.ajax({
        url: 'http://ceshi.kuaijilm.com/api/single_login',
        method: 'post',
        data: {
            values: {
                "uid":uid,
                'device':device,
                'sid':sid,
                'is_exp': is_exp
            }
        }
      },function(ret, err){

        if (ret) {

           if(ret.status==1) {

              callback(ret, err);

           } else if(ret.status==2) {

             $api.setStorage('uid', 0);
             api.toast({
                 msg: '登录过期，正在跳转登录页...'
             });
             var catid=api.pageParam.catid;
             var keysword="";

             setTimeout(function(){
               login();
             },2000);

          } else if(ret.status==3) {
            alert('尚未开通正式课程或者课程已过期，请联系管理开通或者续期');
          }
        }
    });
}

// 打开登录
function login() {
    api.openWin({
        name: 'denglu',
        url: 'login.html'
    });
}

// 退出
function logout() {

    api.confirm({
        msg: '确认退出吗？',
        buttons: ['确定', '取消']
    }, function(ret, err) {
        if (ret && ret.buttonIndex == 1) {

            $api.setStorage('uid', 0);
            api.sendEvent({
                name: 'updateUserCenter',
                extra: {
                    update: 1,
                    uid: 0,
                }
            });

            api.closeWin({
              name: 'setting'
            });
        }
    });
}

//用户协议
//app_name APP名称
//shanghu_name 商户名称
function xieyi(app_name, shanghu_name) {

  app_name = app_name || '会计训练营';
  shanghu_name = shanghu_name || '会计训练营';

  layer.open({
    type: 1,
    scrollbar: true,
    content: '<p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">一、总则</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">1.1 </span><span style="font-family: 宋体;letter-spacing: 0;font-size: 16px"><span style="font-family:宋体">' + app_name + '</span></span><span style="letter-spacing: 0;font-size: 16px">的所有权和运营权归</span><span style="font-family: 宋体;letter-spacing: 0;font-size: 16px"><span style="font-family:宋体">' + shanghu_name + '</span></span><span style="letter-spacing: 0;font-size: 16px">所有。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">1.2 本协议则可由</span><span style="font-family: 宋体;letter-spacing: 0;font-size: 16px"><span style="font-family:宋体">' + shanghu_name + '</span></span><span style="letter-spacing: 0;font-size: 16px">随时更新，用户应当及时关注并同意本应用不承担通知义务。本应用的通知、公告、声明或其它类似内容是本协议的一部分。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">二、服务内容</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">2.1 </span><span style="font-family: 宋体;letter-spacing: 0;font-size: 16px"><span style="font-family:宋体">' + app_name + '</span></span><span style="letter-spacing: 0;font-size: 16px">的具体内容由本应用根据实际情况提供。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">2.2 本应用仅提供相关的网络服务，除此之外与相关网络服务有关的设备(如个人电脑、手机、及其他与接入互联网或移动网有关的装置)及所需的费用(如为接入互联网而支付的电话费及上网费、为使用移动网而支付的手机费)均应由用户自行负担。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">三、用户帐号</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">3.1 经本应用注册系统完成注册程序并通过身份认证的用户即成为正式用户，可以获得本应用规定用户所应享有的一切权限；未经认证仅享有本应用规定的部分会员权限。</span><span style="font-family: 宋体;letter-spacing: 0;font-size: 16px"><span style="font-family:宋体">' + app_name + '</span></span><span style="letter-spacing: 0;font-size: 16px">有权对会员的权限设计进行变更。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">3.2 用户只能按照注册要求使用真实姓名，及身份证号注册。用户有义务保证密码和帐号的安全，用户利用该密码和帐号所进行的一切活动引起的任何损失或损害，由用户自行承担全部责任，本应用不承担任何责任。如用户发现帐号遭到未授权的使用或发生其他任何安全问题，应立即修改帐号密码并妥善保管，如有必要，请通知本应用。因黑客行为或用户的保管疏忽导致帐号非法使用，本应用不承担任何责任。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">四、使用规则</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">4.1 遵守中华人民共和国相关法律法规，包括但不限于《中华人民共和国计算机信息系统安全保护条例》、《计算机软件保护条例》、《最高人民法院关于审理涉及计算机网络著作权纠纷案件适用法律若干问题的解释(法释[2004]1号)》、《全国人大常委会关于维护互联网安全的决定》、《互联网电子公告服务管理规定》、《互联网新闻信息服务管理规定》、《互联网著作权行政保护办法》和《信息网络传播权保护条例》等有关计算机互联网规定和知识产权的法律和法规、实施办法。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">4.2 用户对其自行发表、上传或传送的内容负全部责任，所有用户不得在本应用任何页面发布、转载、传送含有下列内容之一的信息，否则本应用有权自行处理并不通知用户：</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(1)违反宪法确定的基本原则的；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(2)危害国家安全，泄漏国家机密，颠覆国家政权，破坏国家统一的；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(3)损害国家荣誉和利益的；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(4)煽动民族仇恨、民族歧视，破坏民族团结的；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(5)破坏国家宗教政策，宣扬邪教和封建迷信的；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(6)散布谣言，扰乱社会秩序，破坏社会稳定的；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(7)散布淫秽、色情、赌博、暴力、恐怖或者教唆犯罪的；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(8)侮辱或者诽谤他人，侵害他人合法权益的；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(9)煽动非法集会、结社、游行、示威、聚众扰乱社会秩序的；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(10)以非法民间组织名义活动的；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(11)含有法律、行政法规禁止的其他内容的。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">4.3 用户承诺对其发表或者上传于本应用的所有信息(即属于《中华人民共和国著作权法》规定的作品，包括但不限于文字、图片、音乐、电影、表演和录音录像制品和电脑程序等)均享有完整的知识产权，或者已经得到相关权利人的合法授权；如用户违反本条规定造成本应用被第三人索赔的，用户应全额补偿本应用一切费用(包括但不限于各种赔偿费、诉讼代理费及为此支出的其它合理费用)；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">4.4 当第三方认为用户发表或者上传于本应用的信息侵犯其权利，并根据《信息网络传播权保护条例》或者相关法律规定向本应用发送权利通知书时，用户同意本应用可以自行判断决定删除涉嫌侵权信息，除非用户提交书面证据材料排除侵权的可能性，本应用将不会自动恢复上述删除的信息；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(1)不得为任何非法目的而使用网络服务系统；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(2)遵守所有与网络服务有关的网络协议、规定和程序； (3)不得利用本应用进行任何可能对互联网的正常运转造成不利影响的行为；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(4)不得利用本应用进行任何不利于本应用的行为。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">4.5 如用户在使用网络服务时违反上述任何规定，本应用有权要求用户改正或直接采取一切必要的措施(包括但不限于删除用户张贴的内容、暂停或终止用户使用网络服务的权利)以减轻用户不当行为而造成的影响。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">五、隐私保护</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">5.1 本应用不对外公开或向第三方提供单个用户的注册资料及用户在使用网络服务时存储在本应用的非公开内容，但下列情况除外：</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(1)事先获得用户的明确授权；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(2)根据有关的法律法规要求；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(3)按照相关政府主管部门的要求；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(4)为维护社会公众的利益。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">5.2 本应用可能会与第三方合作向用户提供相关的网络服务，在此情况下，如该第三方同意承担与本应用同等的保护用户隐私的责任，则本应用有权将用户的注册资料等提供给该第三方。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">5.3 在不透露单个用户隐私资料的前提下，本应用有权对整个用户数据库进行分析并对用户数据库进行商业上的利用。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">六、版权声明</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">6.1 本应用的文字、图片、音频、视频等版权均归开发者享有或与作者共同享有，未经本应用许可，不得任意转载。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">6.2 本应用特有的标识、版面设计、编排方式等版权均属开发者享有，未经本应用许可，不得任意复制或转载。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">6.3 使用本应用的任何内容均应注明“来源于</span><span style="font-family: 宋体;letter-spacing: 0;font-size: 16px"><span style="font-family:宋体">' + app_name + '</span></span><span style="letter-spacing: 0;font-size: 16px">”及署上作者姓名，按法律规定需要支付稿酬的，应当通知本应用及作者及支付稿酬，并独立承担一切法律责任。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">6.4 本应用享有所有作品用于其它用途的优先权，包括但不限于网站、电子杂志、平面出版等，但在使用前会通知作者，并按同行业的标准支付稿酬。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">6.5 本应用所有内容仅代表作者自己的立场和观点，与本应用无关，由作者本人承担一切法律责任。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">6.6 恶意转载本应用内容的，本应用保留将其诉诸法律的权利。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">七、责任声明</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">7.1 用户明确同意其使用本应用网络服务所存在的风险及一切后果将完全由用户本人承担，</span><span style="font-family: 宋体;letter-spacing: 0;font-size: 16px"><span style="font-family:宋体">' + app_name + '</span></span><span style="letter-spacing: 0;font-size: 16px">对此不承担任何责任。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">7.2 本应用无法保证网络服务一定能满足用户的要求，也不保证网络服务的及时性、安全性、准确性。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">7.3 本应用不保证为方便用户而设置的外部链接的准确性和完整性，同时，对于该等外部链接指向的不由本应用实际控制的任何网页上的内容，本应用不承担任何责任。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">7.4 对于因不可抗力或本应用不能控制的原因造成的网络服务中断或其它缺陷，本应用不承担任何责任，但将尽力减少因此而给用户造成的损失和影响。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">7.5 对于站向用户提供的下列产品或者服务的质量缺陷本身及其引发的任何损失，本应用无需承担任何责任：</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(1)本应用向用户免费提供的各项网络服务；</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">(2)本应用向用户赠送的任何产品或者服务。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">7.6 本应用有权于任何时间暂时或永久修改或终止本服务(或其任何部分)，而无论其通知与否，本应用对用户和任何第三人均无需承担任何责任。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">&nbsp;</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">八、附则</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">8.1 本协议的订立、执行和解释及争议的解决均应适用中华人民共和国法律。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">8.2 如本协议中的任何条款无论因何种原因完全或部分无效或不具有执行力，本协议的其余条款仍应有效并且有约束力。</span></p><p style="margin-top:5px;margin-right:0;margin-bottom:5px;margin-left:0;text-indent:0"><span style="letter-spacing: 0;font-size: 16px">8.3 本协议解释权及修订权归开发者所有。</span></p><p><span style=";font-family:Calibri;font-size:14px">&nbsp;</span></p><p><br/></p>',
    anim: 'up',
    style: 'position:fixed; bottom:0; left:0; width: 100%; height: 300px; border:none;font-size:10px;line-height:25px;letter-spacing:0.5px;overflow:scroll;word-wrap: break-word;padding:20px;box-sizing: border-box;'
  });
}


//长按
var timeOutEvent = 0;
//定时器
//开始按
//elem 元素
//mode 模式：1复制，2识别二维码
//type 复制类型：1微信，2地址，3QQ
function gtouchstart(elem, mode, type) {
  mode = mode || 1;
  type = type || 1;

  timeOutEvent = setTimeout(function() {
      //真正长按后应该执行的内容
      timeOutEvent = 0;

      //执行长按要执行的内容
      //复制内容
      if(mode == 1){

        var data = $(elem).text(),
            msg = '复制客服微信号成功，是否打开微信添加客服？';

        if (type == 2) msg = '复制联系地址成功！';
        if (type == 3) msg = '复制客服QQ号成功，是否打开QQ添加客服？';

        //复制微信号
        var clipBoard = api.require('clipBoard');
        clipBoard.set({
            value: data
        }, function(ret, err) {
            if (ret) {
                clipBoard.get(function(ret, err) {
                    if (ret) {
                      if(type == 2) {
                        api.toast({
                            msg: msg,
                            duration: 3000,
                            location: 'bottom'
                        });
                      } else {
                        api.confirm({
                            title: '',
                            msg: msg,
                            buttons: ['确定', '取消']
                        }, function(ret, err){
                            if(ret && ret.buttonIndex == 1){
                              if (type == 1) {
                                api.openApp({
                                    iosUrl: 'weixin://',
                                    uri: 'weixin://'
                                }, function(ret, err) {
                                    console.log(ret);
                                });

                              } else if (type == 3) {
                                api.openApp({
                                    iosUrl: 'mqq://im/chat?chat_type=wpa&uin=' + data + '&version=1&src_type=web',
                                    uri: 'mqqwpa://im/chat?chat_type=wpa&uin=' + data
                                }, function(ret, err) {
                                    console.log(ret);
                                });
                              }
                            }
                        });
                      }
                    }
                });
            }
        });

      } else if (mode == 2){
        //识别二维码
        var src = $(elem).attr('src');

        api.download({
            url: src,
            allowResume: true
        },function(ret, err){
            if(ret.state == 1){

              api.saveMediaToAlbum({
                  path: ret.savePath
              }, function(ret, err){
                api.confirm({
                    title: '',
                    msg: '图片以保存至相册，打开微信，选择扫一扫，选择相册二维码进行扫描！是否打开微信？',
                    buttons: ['确定', '取消']
                }, function(ret, err){
                    if(ret && ret.buttonIndex == 1){
                      api.openApp({
                          iosUrl: 'weixin://',
                          uri: 'weixin://'
                      }, function(ret, err) {
                          console.log(ret);
                      });
                    }
                });

              });

            }else{

            }
        });

      }

  }, 500);
  //这里设置定时器，定义长按500毫秒触发长按事件，时间可以自己改，个人感觉500毫秒非常合适
  return false;
};
//手释放，如果在500毫秒内就释放，则取消长按事件，此时可以执行onclick应该执行的事件
function gtouchend() {
  clearTimeout(timeOutEvent);
  //清除定时器
  if (timeOutEvent != 0) {
      //这里写要执行的内容（尤如onclick事件）
      // alert("你这是点击，不是长按");
  }
  return false;
};
//如果手指有移动，则取消所有事件，此时说明用户只是要移动而不是长按
function gtouchmove() {
  clearTimeout(timeOutEvent);
  //清除定时器
  timeOutEvent = 0;
};

//读文件
function readFile(path, callBack) {
    callBack = callBack || '';
    var fs = api.require('fs');
    var retopen = fs.openSync({
        path: 'fs://' + path,
        flags: 'read_write'
    });
    var retread = fs.readSync({
        fd: retopen.fd,
        offset: 0,
        length: 0
    });
    if (callBack) {
      callBack(retread);
    } else {
      return retread;
    }
}

//写文件
function writeFile(json, id, path) {
    var fs = api.require('fs');
    var ret = fs.createDirSync({
        path: 'fs://' + path
    });
    var ret = fs.createFileSync({
        path: 'fs://' + path + '/' + id + '.txt'
    });

    var retopen = fs.openSync({
        path: 'fs://' + path + '/' + id + '.txt',
        flags: 'read_write'
    });

    var retwrite = fs.writeSync({
        fd: retopen.fd,
        data: JSON.stringify(json),
        offset: 0
    });
    //alert(JSON.stringify(json));


    //缓存目录
    // var cacheDir = api.cacheDir;
    // api.writeFile({
    // 	//保存路径
    // 	path : cacheDir + '/' + path + '/' + id + '.json',
    // 	//保存数据，记得转换格式
    // 	data : JSON.stringify(json)
    // }, function(ret, err) {
    //
    // })
}

//缓存方法
function doCache(folder, id, url, datas) {
    readFile(folder + '/' + id + '.txt', function(ret) {
        if (ret.status) {
            //如果成功，说明有本地存储，读取时转换下数据格式
            //拼装json代码
            //alert('取到缓存')
            var cacheData = ret.data;
            //alert(cacheData);
            //	callback(JSON.parse(cacheData));
            //iCache($('.cache'));
            //再远程取一下数据，防止有更新
            ajaxRequest(url, 'GET', datas, function(ret, err) {
                if (ret) {
                    //alert(cacheData);
                    //	alert(JSON.stringify(ret));
                    if (cacheData != JSON.stringify(ret)) {
                        //	alert(1);

                        var fs = api.require('fs');
                        var retmove = fs.removeSync({
                            path: 'fs://' + folder + '/' + id + '.txt'
                        });
                        // alert(retmove.status);
                        // alert(JSON.stringify(ret));
                        //有更新处理返回数据
                        //	alert(ret);
                        ///callback(ret);
                        //缓存数据
                        writeFile(ret, id, folder);
                        //iCache($('.cache'));
                    }
                } else {
                    alert('数据获取失败！');
                }
            })
        } else {
            //如果失败则从服务器读取，利用上面的那个ajaxRequest方法从服务器GET数据
            ajaxRequest(url, 'GET', datas, function(ret, err) {
                if (ret) {
                    //处理返回数据
                    //alert('没取到缓存')
                    //alert(ret);
                    //callback(ret);
                    //缓存数据
                    writeFile(ret, id, folder);
                    //	iCache($('.cache'));
                } else {
                    alert('数据获取失败！');
                }
            })
        }
    })
}

//缓存图片
function iCache(selector) {
    selector.each(function(data) {
        ! function(data) {
            var url = selector.eq(data).attr("src");
            var img = this;
            var pos = url.lastIndexOf("/");
            var filename = url.substring(pos + 1);
            var path = api.cacheDir + "/pic/" + filename;
            var obj = api.require('fs');
            obj.exist({
                path: path
            }, function(ret, err) {
                //msg(ret);
                if (ret.exist) {
                    if (ret.directory) {
                        //api.alert({msg:'该路径指向一个文件夹'});
                    } else {
                        //api.alert({msg:'该路径指向一个文件'});
                        //selector.eq(data).src=path;
                        selector.eq(data).attr('src', null);
                        path = api.cacheDir + "/pic/" + filename;
                        selector.eq(data).attr('src', path);
                        //console.log(selector.eq(data).attr("src"));
                    }
                } else {
                    api.download({
                        url: url,
                        savePath: path,
                        report: false,
                        cache: true,
                        allowResume: true
                    }, function(ret, err) {
                        //msg(ret);
                        if (ret) {
                            var value = ('文件大小：' + ret.fileSize + '；下载进度：' + ret.percent + '；下载状态' + ret.state + '存储路径: ' + ret.savePath);
                        } else {
                            var value = err.msg;
                        };
                    });
                } //即可自动实现图片缓存
            });
        };
    })
}


function PullRefresh(path, where) {
    api.setRefreshHeaderInfo({
        visible: true,
        bgColor: '#f9f9f9',
        textColor: '#999',
        textDown: '下拉刷新...',
        textUp: '松开刷新...',
        showTime: false
    }, function(ret, err) {

        fnGetList(true, path, where);
    });
  //   api.setCustomRefreshHeaderInfo({
  //     bgColor: '#f0f0f0',
  //     isScale: true,
  // }, function() {
  //     fnGetList(true, path, where);
  // });

};

function PushRefresh(path, where) {
    api.addEventListener({
        name: 'scrolltobottom',
        extra:{
            threshold: 100            //设置距离底部多少距离时触发，默认值为0，数字类型
        }
    }, function(ret, err) {
        api.showProgress({
          title: '请稍候...',
          text: '努力加载中...',
          modal: false
        });

        fnGetList(true, path, where, ++page);
    });
};

function init(path, where) {
    fnGetList(false, path, where, page = 1);
};


var LIMIT = 8;

function fnGetList(isPull, path, where, page) {
    fnGet(path, where, page, LIMIT, function(ret, err) {
        api.hideProgress();
        api.refreshHeaderLoadDone();

        // alert(JSON.stringify(ret));
        fnShowList(ret, isPull);
    });
};


function fnCacheImage(datas, index) {
    if (datas.length <= index) {
        return;
    }

    api.imageCache({
        url: datas[index].thumbnail.url
    }, function(ret, err) {
        var thumbnail = $api.byId('thumbnail_' + datas[index].id);
        if (thumbnail) {
            thumbnail.src = ret.url;
        }

        fnCacheImage(datas, index + 1);
    });
};

function fnGet(path, where, page, limit, callback) {

    //  api.showProgress({
    //      title: '努力加载中',
    //      modal: false
    //  });
    //alert(serverurl + path +'?page='+ page + '&limit=' + LIMIT+where);
    api.ajax({
        url: serverurl + path + '?page=' + page + '&limit=' + LIMIT + where,
        method: 'get',
        timeout: 5,
        dataType: 'json',
        //  headers: {
        //      "X-APICloud-AppId": appid,
        //      "X-APICloud-AppKey": appKey
        //  }
    }, function(ret, err) {
        //alert(JSON.stringify(ret['bannar']));
        api.refreshHeaderLoadDone();
        api.hideProgress();
        callback(ret, err);
    });
};

function fnPost(path, data, isPut, callback) {
    var url = path.slice(0,4)=='http' ? path : serverurl + path
    // var headers = {
    // 		"X-APICloud-AppId": appid,
    // 		"X-APICloud-AppKey": appkey
    // };

    // api.showProgress({
    // 		title: '通信中',
    // 		modal: false
    // });
    api.ajax({
        url: url,
        method: isPut ? 'put' : 'post',
        timeout: 5,
        dataType: 'json',
        returnAll: false,
        //	headers: headers,
        data: data
    }, function(ret, err) {
        api.refreshHeaderLoadDone();
        api.hideProgress();
        callback(ret, err);
    });
};

/*
*打开新页面
* type  页面名称
* val   数据值，比如ID
* title   页面动态标题
* order_id   订单ID
*/
function openNewWindow(type, val, title, order_id) {

    order_id = order_id || '';

    api.sendEvent({
        name: 'pause_bf',
        extra: {
            pause: "start",
        }
    });
    iCache($('.cache'));
    var uid = $api.getStorage('uid');
    var footerH = 48;
    //frame的高度为当前window高度减去header和footer的高度
    var frameH = api.winHeight - footerH;
    if (type == 'ask' || type == 'usercenter') {

        api.openWin({
            name: title,
            url: type + '.html',
            //	delay:800,
            bounces: false,
            animation: {
                type: "movein", //动画类型（详见动画类型常量）
                subType: "from_right", //动画子类型（详见动画子类型常量）
                duration: 300 //动画过渡时间，默认300毫秒
            },
            bgColor: '#fff',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: frameH
            },
            pageParam: {
                title: title,
                search: val
            }
        });
    } else if (type == 'livelist') {
        api.openWin({
            name: title,
            url: 'livelist.html',
            //delay:1500,
            bounces: false,
            bgColor: '#fff',
            animation: {
                type: "movein", //动画类型（详见动画类型常量）
                subType: "from_right", //动画子类型（详见动画子类型常量）
                duration: 300 //动画过渡时间，默认300毫秒
            },
            progress: 'page',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: frameH
            },
            pageParam: {
                title: title,

            }
        });
    } else if (type == 'home') {
        api.openWin({
            name: title,
            url: 'home.html',
            //	delay:800,
            bounces: false,
            animation: {
                type: "movein", //动画类型（详见动画类型常量）
                subType: "from_right", //动画子类型（详见动画子类型常量）
                duration: 300 //动画过渡时间，默认300毫秒
            },
            bgColor: '#fff',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: 'auto'
            },
            pageParam: {
                title: title,

            }
        });
    } else if (type == 'question_detail') {
        api.openWin({
            name: title,
            url: 'question_detail.html',
            //delay:100,
            bounces: false,
            bgColor: '#fff',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: frameH
            },
            pageParam: {
                title: title,
                question_id: val
            }
        });

    } else if (type == 'free_data_detail') {
        api.openWin({
            name: title,
            url: 'free_data_detail.html',
            //delay:100,
            bounces: false,
            bgColor: '#fff',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: frameH
            },
            pageParam: {
                title: title,
                free_data_id: val
            }
        });

    }  else if (type == 'tiku_index' || type == 'tiku_list') {

        api.openWin({
            name: type,
            url: type + '.html',
            //delay:100,
            bounces: false,
            bgColor: '#fff',
            pageParam: {
                title: title,
                sid: val
            }
        });
    } else {

        api.openWin({
            name: title,
            url: type + '.html',
            //	delay:100,
            bounces: false,
            animation: {
                type: "movein", //动画类型（详见动画类型常量）
                subType: "from_right", //动画子类型（详见动画子类型常量）
                duration: 300 //动画过渡时间，默认300毫秒
            },
            bgColor: '#fff',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: frameH
            },
            pageParam: {
                title: title,
                catid: val,
                order_id: order_id,
                kcid: ""
            }
        });
    }
}


function openWindow(type, sid, kslx, analog_type) {
    api.openWin({
        name: type,
        url: type + '.html',
        //delay:100,
        bounces: false,
        bgColor: '#fff',
        pageParam: {
            kslx: kslx,
            sid: sid,
            analog_type: analog_type
        }
    });
}

/**
* 打开头部内容分离页面
* name 页面名称
* pageParam 页面参数
*/
function openWindowFrame(name, pageParam){

    api.openWin({
        name: name,
        url: name + '.html',
        bounces: false,
        bgColor: '#fff',
        pageParam: pageParam ? pageParam : {}
    });
}

//进入答题页面
function answer(type, sid, xiaojie_id, kslx, analog_type) {

    var uid = $api.getStorage('uid');
    if (uid > 0) {

      api.openWin({
          name: type,
          url: type + '.html',
          //delay:100,
          bounces: false,
          bgColor: '#fff',
          pageParam: {
              kslx: kslx,
              sid: sid,
              xiaojie_id: xiaojie_id,
              analog_type: analog_type
          },
          reload: true
      });

    } else {
      login();
    }
}

//清空做题记录
function clear_record(event, sid, xiaojie_id, kslx, analog_type) {
    event.stopPropagation();

    var uid = $api.getStorage('uid');
    if (uid > 0) {

      api.confirm({
          title: '',
          msg: '确定清空做题记录，重新做题吗？',
          buttons: ['确定重做', '取消']
      }, function(ret, err) {
          var index = ret.buttonIndex;
          if (index == 1) {
              //	uid=669&xiaojieid=147&clear=clear
              var db = api.require('db');
              var dbName = "kuaijilm";
              var exam_history_del = "DELETE FROM exam_historys WHERE  uid =" + uid + " and xiaojie_id=" + xiaojie_id;
              //alert(order_del);
              var del_ret = db.executeSqlSync({
                  name: dbName,
                  sql: exam_history_del
              });

              var data = {
                  values: {
                      "xiaojieid": xiaojie_id,
                      "uid": uid,
                      "clear": "clear"
                  }
              };
              //alert(JSON.stringify(data));
              var path = "exam/store";
              var isPut = false;
              fnPost(path, data, isPut, function(ret, err) {
                  if (ret.status == 1) {
                      api.toast({
                          msg: '清空做题记录完成，正在前往重新做题',
                          duration: 2000,
                          location: 'bottom'
                      });

                      setTimeout(function(){

                        answer('tiku_exam', sid, xiaojie_id, kslx, analog_type);

                     }, 2000);
                  }
              })
          }
      });
    } else {
      login();
    }
}

function SetString(str, len) {
    var strlen = 0;
    var s = "";
    for (var i = 0; i < str.length; i++) {
        if (str.charCodeAt(i) > 128) {
            strlen += 2;
        } else {
            strlen++;
        }
        s += str.charAt(i);
        if (strlen >= len) {
            return s;
        }
    }
    return s;
}


function htmldecode(str) {
    str = str.replace(/&amp;/g, '&');
    str = str.replace(/&nbsp;/g, ' ');
    str = str.replace(/&quot;/g, '"');
    str = str.replace(/&#39;/g, "'");
    str = str.replace(/&lt;/gi, '<');
    str = str.replace(/&gt;/gi, '>');
    //	str = str.replace(/<p>/g, '');
    //	str = str.replace(/<\/p>/g, '');
    //	str = str.replace(/<img/g, '<img style="width:100%;"');
    return str;
}


function isEmpty(obj) {
    // 用变量保存可以加速对对象原型的hasOwnProperty的访问。
    var hasOwnProperty = Object.prototype.hasOwnProperty;
    // 本身为空直接返回true
    if (obj == null) return true; // 然后可以根据长度判断，在低版本的ie浏览器中无法这样判断。
    if (obj == 'null') return true;
    if (obj.length > 0) return false;
    if (obj.length === 0) return true; //最后通过属性长度判断。
    for (var key in obj) {
        if (hasOwnProperty.call(obj, key))
            return false;
    }
    return true;
}

//aa数组是否包含bb数组
function isContained(aa, bb) {
    if (!(aa instanceof Array) || !(bb instanceof Array) || ((aa.length < bb.length))) {
        return false;
    }
    var aaStr = aa.toString();
    for (var i = 0; i < bb.length; i++) {
        if (aaStr.indexOf(bb[i]) < 0) return false;
    }
    return true;
}


//字符串转换为时间戳
function getDateTimeStamp(dateStr) {
    return Date.parse(dateStr.replace(/-/gi, "/"));
}

function getDateDiff(dateStr) {
    var publishTime = getDateTimeStamp(dateStr) / 1000,
        d_seconds,
        d_minutes,
        d_hours,
        d_days,
        d_months,
        d_years,
        timeNow = parseInt(new Date().getTime() / 1000),
        d,

        date = new Date(publishTime * 1000),
        Y = date.getFullYear(),
        M = date.getMonth() + 1,
        D = date.getDate(),
        H = date.getHours(),
        m = date.getMinutes(),
        s = date.getSeconds();

    //	alert(publishTime);alert(timeNow);
    //小于10的在前面补0
    if (M < 10) {
        M = '0' + M;
    }
    if (D < 10) {
        D = '0' + D;
    }
    if (H < 10) {
        H = '0' + H;
    }
    if (m < 10) {
        m = '0' + m;
    }
    if (s < 10) {
        s = '0' + s;
    }

    d = timeNow - publishTime;
    if (d < 60) {
        if (d < 10) {
            return '刚刚发表';
        } else {
            return d + '秒前';
        }
    } else {
        d_years = parseInt(d / 31536000);
        d_months = parseInt(d / 2592000);
        d_days = parseInt(d / 86400);
        d_hours = parseInt(d / 3600);
        d_minutes = parseInt(d / 60);
        d_seconds = parseInt(d);
    }

    if (d_years > 0) {
        return d_years + '年前';
    } else if (d_months > 0 && d_years <= 0) {
        return d_months + '月前';
    } else if (d_days > 0 && d_days < 31) {
        return d_days + '天前';
    } else if (d_days <= 0 && d_hours > 0) {
        return d_hours + '小时前';
    } else if (d_hours <= 0 && d_minutes > 0) {
        return d_minutes + '分钟前';
    } else if (d_seconds < 60) {
        if (d_seconds <= 0) {
            return '刚刚发表';
        } else {
            return d_seconds + '秒前';
        }
    } else if (d_days >= 3 && d_days < 30) {
        return M + '-' + D + '&nbsp;' + H + ':' + m;
    } else if (d_days >= 30) {
        return Y + '-' + M + '-' + D + '&nbsp;' + H + ':' + m;
    }
}

var time_to_sec = function(time) {
    var s = '';

    if(!isEmpty(time)){
      var time_arr = time.split(':');

      if (time_arr.length == 1) {
        var sec = time.split(':')[0];

      } else if (time_arr.length == 2) {

        var min = time.split(':')[0],
            sec = time.split(':')[1];

      } else if (time_arr.length == 3) {

        var hour = time.split(':')[0];
        var min = time.split(':')[1];
        var sec = time.split(':')[2];
      }

      hour = hour ? hour : 0;
      min = min ? min : 0;
      sec = sec ? sec : 0;

      s = Number(hour * 3600) + Number(min * 60) + Number(sec);
    }

    return s;
};

function formatTime(second) {
    return [parseInt(second / 60), parseInt(second % 60)].join(":")
        .replace(/\b(\d)\b/g, "0$1");
}

//时间戳转字符串
function timestampToTime(timestamp) {
    var date = new Date(timestamp * 1000); //时间戳为10位需*1000，时间戳为13位的话不需乘1000
    Y = date.getFullYear() + '-';
    M = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1) + '-';
    D = (date.getDate() < 10 ? '0' + date.getDate() : date.getDate()) + '   ';
    h = (date.getHours() < 10 ? '0' + date.getHours() : date.getHours()) + ':';
    m = (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes()) + ':';
    s = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    return Y + M + D + '  ' + h + m + s;
}
// timestampToTime(1403058804);
// console.log(timestampToTime(1403058804));//2014-06-18 10:33:24
var subSet = function(arr1, arr2) {
    var len = arr1.length;
    var arr = [];

    while (len--) {
        if (!inArray(arr1[len], arr2)) {
            //console.info(arr1[len])
            arr.push(arr1[len]);
        }
    }

    return arr;
};

function inArray(search, array) {
    for (var i in array) {
        if (array[i] == search) {
            return true;
        }
    }
    return false;
}

function str_to_arr(str, dot) {
    if (isEmpty(str)) {
        return [];
    }
    return str.split(dot);
}


function remove(arr, val) {
    for (var i = 0; i < arr.length; i++) {
        if (arr[i] == val) {
            arr.splice(i, 1);
        }
    }
    return arr;
}

function type_name(catid) {
    return {
        '1': '单选题',
        '2': '多选题',
        '3': '判断题',
        '5': (catid == 86) ? '不定项选择' : '计算分析题',
        '6': '简答题',
        '7': '综合题',
        '8': '计算回答题',
        '9': '案例分析题',
        '10': '综合分析题',
        '11': '计算题'
    };
}


var cn_int = ['一', '二', '三', '四', '五', '六', '七', '八', '九', '十', '十一', '十二', '十三', '十四', '十五', '十六', '十七', '十八', '十九', '二十'];

function get_array_index(search, array) {
    for (var i in array) {
        if (array[i] == search) {
            return i;
        }
    }
    return -1;
}

//重名名视频
//vid 视频ID
//视频初始类型
//转化后类型
function renamefile(vid, init_type, make_type) {
    var fs = api.require('fs');
    var ret = fs.renameSync({
        oldPath:'fs://.tmp/.'+vid+'/0.'+init_type,
        newPath: 'fs://.tmp/.'+vid+'/0.'+make_type
    });

    if(ret.status) {
      return true;
    } else {
      renamefile(vid,init_type,make_type);
    }
}
