var opts = {
      token: null,
      interval: 60,
      voice: false,
      requestUrl: null,
      requestData: null,

      language: {
          sending: '短信发送中...',
          failed: '请求失败，请重试',
          resendable: '{{seconds}} s 重新发送'
      }
  },
  btnOriginContent = $('#sendVerifySmsButton').html() || $('#sendVerifySmsButton').val() || '';

$(function(){

  var resize = function() {
    var bodyHei = $(window).height();
    $("body").css("height", bodyHei + "px");
  }
  resize();
  $(window).resize(function() {
    resize();
  })

  //密码显示隐藏
  $(document).on('touchend','.eye',function(){
  	var input = $(this).siblings('input'),
  			type = input.attr('type');

  	if(type == 'password'){

  		$(this).find('img').attr('src','../image/icon/eye-off-outline.png');
  		input.attr('type', 'text');

  	} else if(type == 'text'){

  		$(this).find('img').attr('src','../image/icon/eye-outline.png');
  		input.attr('type', 'password');
  	}

  });

});


//定时器
function timer(seconds) {
    seconds = seconds || opts.interval;

    var btnText = opts.language.resendable;
    btnText = typeof btnText === 'string' ? btnText : '';
    if (seconds < 0) {
        clearTimeout(timeId);
        changeBtn(btnOriginContent, false);
    } else {
        timeId = setTimeout(function() {
            clearTimeout(timeId);
            changeBtn(btnText.replace('{{seconds}}', (seconds--) + ''), true);
            timer(seconds);
        }, 1000);
    }
}

//改变发送验证码按钮状态
function changeBtn(content, disabled) {
    $('#sendVerifySmsButton').html(content);
    $('#sendVerifySmsButton').val(content);
    $('#sendVerifySmsButton').prop('disabled', !!disabled);
}
